/**
 *
 */
package tsuteto.smashbat;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import net.minecraft.block.Block;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.network.INetworkManager;
import net.minecraft.network.packet.Packet250CustomPayload;
import net.minecraft.src.ModLoader;
import net.minecraftforge.common.Configuration;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.ForgeSubscribe;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.living.LivingEvent.LivingUpdateEvent;
import net.minecraftforge.event.entity.living.LivingFallEvent;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.network.IPacketHandler;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.common.network.Player;

/**
 * @author Tsuteto
 *
 */
@Mod(modid = SmashBatMod.modid, name = "Smash Bats Mod", version = "1.4.5-MC1.6.2")
public class SmashBatMod
{
    public static final String modid = "SmashBatsMod";

    public static int woodSmashBatId = 3558;
    public static int ironSmashBatId = 3559;
    public static int goldSmashBatId = 3560;
    public static int diamondSmashBatId = 3561;
    public static int creeperSmashBatId = 3562;
    public static int tntSmashBatId = 3563;
    public static int thunderSmashBatId = 3564;
    public static int ridingSmashBatId = 3565;
    public static boolean use32xTexture = false;

    public static Item itemSmashBatWood;
    public static Item itemSmashBatIron;
    public static Item itemSmashBatGold;
    public static Item itemSmashBatDiamond;
    public static Item itemSmashBatCreeper;
    public static Item itemSmashBatTnt;
    public static Item itemSmashBatThunder;
    public static Item itemSmashBatRiding;

    @SidedProxy(clientSide = "tsuteto.smashbat.SmashBatMod$ClientProxy", serverSide = "tsuteto.smashbat.SmashBatMod$ServerProxy")
    public static ISidedProxy sidedProxy;

    @Mod.EventHandler
    public void preload(FMLPreInitializationEvent event)
    {
        Configuration conf = new Configuration(event.getSuggestedConfigurationFile());
        conf.load();

        woodSmashBatId = conf.get("item", "woodSmashBatId", woodSmashBatId).getInt();
        ironSmashBatId = conf.get("item", "ironSmashBatId", ironSmashBatId).getInt();
        goldSmashBatId = conf.get("item", "goldSmashBatId", goldSmashBatId).getInt();
        diamondSmashBatId = conf.get("item", "diamondSmashBatId", diamondSmashBatId).getInt();
        creeperSmashBatId = conf.get("item", "launchingSmashBatId", creeperSmashBatId).getInt();
        tntSmashBatId = conf.get("item", "blowingSmashBatId", tntSmashBatId).getInt();
        thunderSmashBatId = conf.get("item", "lightningSmashBatId", thunderSmashBatId).getInt();
        ridingSmashBatId = conf.get("item", "ridingSmashBatId", ridingSmashBatId).getInt();
        use32xTexture = conf.get("general", "use32xTexture", use32xTexture, "If true, the bats use 32x resolution textures by ryomaco_514.").getBoolean(false);

        conf.save();

        sidedProxy.installSoundFiles();
    }

    @Mod.EventHandler
    public void load(FMLInitializationEvent event)
    {
        MinecraftForge.EVENT_BUS.register(new EventHandler());
        NetworkRegistry.instance().registerChannel(new SmashBatPacketHandler(), "smashbat");

        itemSmashBatWood = new ItemSmashBat(woodSmashBatId, ItemSmashBat.EnumMaterial.WOOD)
                .setUnlocalizedName("smashbat:smashBatWood");
        itemSmashBatIron = new ItemSmashBat(ironSmashBatId, ItemSmashBat.EnumMaterial.IRON)
                .setUnlocalizedName("smashbat:smashBatIron");
        itemSmashBatGold = new ItemSmashBat(goldSmashBatId, ItemSmashBat.EnumMaterial.GOLD)
                .setUnlocalizedName("smashbat:smashBatGold");
        itemSmashBatDiamond = new ItemSmashBat(diamondSmashBatId, ItemSmashBat.EnumMaterial.EMERALD)
                .setUnlocalizedName("smashbat:smashBatDiamond");
        itemSmashBatCreeper = new ItemSmashBat(creeperSmashBatId, ItemSmashBat.EnumMaterial.CREEPER)
                .setUnlocalizedName("smashbat:smashBatCreeper");
        itemSmashBatTnt = new ItemSmashBat(tntSmashBatId, ItemSmashBat.EnumMaterial.BLAST)
                .setUnlocalizedName("smashbat:smashBatTnt");
        itemSmashBatThunder = new ItemSmashBat(thunderSmashBatId, ItemSmashBat.EnumMaterial.THUNDER)
                .setUnlocalizedName("smashbat:smashBatThunder");
        itemSmashBatRiding = new ItemSmashBat(ridingSmashBatId, ItemSmashBat.EnumMaterial.RIDING)
                .setUnlocalizedName("smashbat:smashBatRiding");

        ModLoader.addName(itemSmashBatWood, "en_US", "Wooden Smash Bat");
        ModLoader.addName(itemSmashBatWood, "ja_JP", "木製スマッシュバット");
        ModLoader.addName(itemSmashBatIron, "en_US", "Metal Smash Bat");
        ModLoader.addName(itemSmashBatIron, "ja_JP", "金属スマッシュバット");
        ModLoader.addName(itemSmashBatGold, "en_US", "Golden Smash Bat");
        ModLoader.addName(itemSmashBatGold, "ja_JP", "黄金スマッシュバット");
        ModLoader.addName(itemSmashBatDiamond, "en_US", "Diamond Smash Bat");
        ModLoader.addName(itemSmashBatDiamond, "ja_JP", "ダイヤスマッシュバット");
        ModLoader.addName(itemSmashBatCreeper, "en_US", "Launching Smash Bat");
        ModLoader.addName(itemSmashBatCreeper, "ja_JP", "打ち上げスマッシュバット");
        ModLoader.addName(itemSmashBatTnt, "en_US", "Blast Smash Bat");
        ModLoader.addName(itemSmashBatTnt, "ja_JP", "爆裂スマッシュバット");
        ModLoader.addName(itemSmashBatThunder, "en_US", "Lightning Smash Bat");
        ModLoader.addName(itemSmashBatThunder, "ja_JP", "イナズマスマッシュバット");
        ModLoader.addName(itemSmashBatRiding, "en_US", "Riding Smash Bat");
        ModLoader.addName(itemSmashBatRiding, "ja_JP", "ライディングスマッシュバット");

        ModLoader.addRecipe(new ItemStack(itemSmashBatWood),
                "X",
                "X",
                "Y",
                Character.valueOf('X'), Block.planks,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatIron),
                "X",
                "X",
                "Y",
                Character.valueOf('X'), Item.ingotIron,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatGold),
                "X",
                "X",
                "Y",
                Character.valueOf('X'), Item.ingotGold,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatDiamond),
                "X",
                "X",
                "Y",
                Character.valueOf('X'), Item.diamond,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatCreeper),
                "X|X",
                "X|X",
                " Y ",
                Character.valueOf('X'), Item.gunpowder,
                Character.valueOf('|'), Item.blazeRod,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatTnt),
                "#",
                "#",
                "Y",
                Character.valueOf('#'), Block.tnt,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatThunder),
                "ΔXΔ",
                "ΔXΔ",
                " Y ",
                Character.valueOf('Δ'), Item.glowstone,
                Character.valueOf('X'), Item.ingotIron,
                Character.valueOf('Y'), Item.leather
        );
        ModLoader.addRecipe(new ItemStack(itemSmashBatRiding),
                "T",
                "T",
                "Y",
                Character.valueOf('T'), Item.carrot,
                Character.valueOf('Y'), Item.leather
        );
    }

    public static void sendSmashToClient(Entity player, double vecX, double vecY, double vecZ)
    {
        ByteArrayOutputStream bytes = new ByteArrayOutputStream();
        DataOutputStream data = new DataOutputStream(bytes);
        try
        {
            data.writeDouble(vecX);
            data.writeDouble(vecY);
            data.writeDouble(vecZ);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }

        PacketDispatcher.sendPacketToPlayer(new Packet250CustomPayload("smashbat", bytes.toByteArray()),
                (Player) player);
    }

    public static class EventHandler
    {
        @ForgeSubscribe
        public void onEntityLivingUpdate(LivingUpdateEvent event)
        {
            Entity entity = event.entity;
            ItemSmashBat.SmashEntry entrySmash = ItemSmashBat.smashEntryMap.get(entity.entityId);
            if (entrySmash != null && entity instanceof EntityPlayerMP)
            {
                entity.addVelocity(entrySmash.velocity.xCoord, entrySmash.velocity.yCoord, entrySmash.velocity.zCoord);
                sendSmashToClient(entity, entrySmash.velocity.xCoord, entrySmash.velocity.yCoord,
                        entrySmash.velocity.zCoord);
                ItemSmashBat.smashEntryMap.remove(entity.entityId);
            }

            if (!entity.worldObj.isRemote && entity.fallDistance > 0.5)
            {
                ItemSmashBat.SmashEntry entryImpact = ItemSmashBat.eventEntryMap.get(entity.entityId);
                if (entryImpact != null && entryImpact.material.delayedEvent != null)
                {
                    entryImpact.material.delayedEvent.onEvent(entryImpact, entity);
                    ItemSmashBat.eventEntryMap.remove(event.entity.entityId);
                }
            }
        }

        @ForgeSubscribe
        public void onEntityLivingFall(LivingFallEvent event)
        {
            ItemSmashBat.eventEntryMap.remove(event.entity.entityId);
        }

        @ForgeSubscribe
        public void onEntityLivingDead(LivingDeathEvent event)
        {
            ItemSmashBat.eventEntryMap.remove(event.entity.entityId);
            ItemSmashBat.smashEntryMap.remove(event.entity.entityId);
        }
    }

    /**
     * Packet handler for the players smashed by the bats
     *
     * @author Tsuteto
     *
     */
    private static class SmashBatPacketHandler implements IPacketHandler
    {
        @Override
        public void onPacketData(INetworkManager manager, Packet250CustomPayload packet, Player player)
        {
            // Read packet
            DataInputStream dataStream = new DataInputStream(new ByteArrayInputStream(packet.data));
            double vecX, vecY, vecZ;
            try
            {
                vecX = dataStream.readDouble();
                vecY = dataStream.readDouble();
                vecZ = dataStream.readDouble();
            }
            catch (IOException e)
            {
                e.printStackTrace();
                return;
            }

            ((EntityPlayer) player).addVelocity(vecX, vecY, vecZ);
        }
    }

    public static class ClientProxy implements ISidedProxy
    {
        @Override
        public void installSoundFiles()
        {
            MinecraftForge.EVENT_BUS.register(new SoundHandler());
        }
    }

    public static class ServerProxy implements ISidedProxy
    {
        @Override
        public void installSoundFiles()
        {
        }
    }

    public static interface ISidedProxy
    {
        void installSoundFiles();
    }

}
